#include "ldrom.h"

void FMC_Open(void)
{
    SYSCLK->AHBCLK |=  4 ;                         // ʹISPʱ
    FMC->ISPCON    |=  FMC_ISPCON_ISPEN_Msk ;      // ʹISP
    FMC->ISPCON    |=  FMC_ISPCON_LDUEN_Msk ;      // ʹLDROM¹
}
void FMC_Erase(uint32_t u32addr)
{
    FMC->ISPCMD = FMC_ISPCMD_PAGE_ERASE ;          // ISP: ҳ
    FMC->ISPADR = u32addr ;
    FMC->ISPTRG = 0x1 ;
    while(FMC->ISPTRG) ;
}
void FMC_Write(uint32_t u32addr, uint32_t u32data)
{
    FMC->ISPCMD = FMC_ISPCMD_PROGRAM ;             // ISP: ֱ
    FMC->ISPADR = u32addr ;
    FMC->ISPDAT = u32data ;
    FMC->ISPTRG = 0x1 ;
    while(FMC->ISPTRG) ;
}
uint32_t FMC_Read(uint32_t u32addr)
{
    FMC->ISPCMD = FMC_ISPCMD_READ ;                // ISP: ֶȡ
    FMC->ISPADR = u32addr ;
    FMC->ISPDAT = 0 ;
    FMC->ISPTRG = 0x1 ;
    while(FMC->ISPTRG) ;
    return FMC->ISPDAT ;
}
void FMC_Close(void)
{
    SYSCLK->AHBCLK |=  4 ;                         // ʹISPʱ
    FMC->ISPCON &= ~FMC_ISPCON_ISPEN_Msk ;         // ֹISP
    FMC->ISPCON &= ~FMC_ISPCON_LDUEN_Msk ;         // ֹLDROM¹
}

void UnlockReg(void)
{
    SYS->REGWRPROT = 0x59 ;
    SYS->REGWRPROT = 0x16 ;
    SYS->REGWRPROT = 0x88 ;
}
void LockReg(void)
{
    SYS->REGWRPROT = 0 ;
}
